function     [eigenvectors,similarity,gamma,rho]       =Fast_density_Clustering(percent,K,eigenvectors)
%=======================================================
  distancecalmethod              ='Eucldian';
method                           =2; % 1. no scaling problem, 2, scaling calculation
%%=========================================================================
 for f                           =1:K/2+1 
%%========================================================================= 
blocknumber                       =size(eigenvectors{f},2);
%==========================================================================
referenceblock                    =1:blocknumber;
  for t                           =1:blocknumber
      index                       =(t-1)*blocknumber+1: t*blocknumber;
     y(index)                     =repmat(t,blocknumber,1);
  end  
   z                              =repmat(referenceblock',blocknumber,1);
%%=========================================================================
if   strcmp(distancecalmethod ,'Eucldian')==1
  [distance,~]                     =distance_calculation(eigenvectors{f}.',method); 
elseif   strcmp(distancecalmethod ,'Angle')==1
  [distance]                       =anglecalculation(eigenvectors{f});
  
end
%==========================================================================
   similarity{f}                   =distance;
     x                             =reshape(similarity{f},blocknumber^2,1); 
   xx(:,1)                         =y;
   xx(:,2)                         =z;
   xx(:,3)                         =x;
   [Gamma,Rho,Delta]               =originalcluster_dp(xx,percent);
 %%========================================================================
  newGamma{f}                                   =Gamma;
 %=========================================================================  
   [~,newloc]                                    =sort(newGamma{f},'descend'); 
 %========================================================================= 
    gamma{f}                                     =newGamma{f}(newloc);
    rho{f}                                       =Rho(newloc);
   eigenvectors{f}                               =eigenvectors{f}(:,newloc);  
  similarity{f}                                  =similarity{f}(newloc,newloc);
 %========================================================================  
   xx=[];
   x=[];
   y=[];
   z=[];
 end
end