function    [estH]     =Proposed_clustering_method(m, percent,F,eigenvectors,Nsources)
%==========================================================================
sT=F/2+1;
[eigenvectors,similarity,gamma,rho]             =Fast_density_Clustering(percent,F,eigenvectors);
[estH]                                          =Sort_eigenvectors(Nsources,eigenvectors,F);
%===================Channel Estimation Adjustment===========================
[bin_estnumber]                                 =Source_number_detection(similarity,gamma,F);
[estH]                                         =Adjustchannelestimation(eigenvectors,estH,similarity,gamma,rho,sT,Nsources,bin_estnumber);
[estH]                                         =EVDmethod(eigenvectors,estH,sT,m,Nsources);
end
%%%========================================================================
 function    [bin_estnumber]                   =Source_number_detection(similarity,gamma,F)  
%--------------------------------------------------------------------------
sT                                             =F/2+1;
 bin_estnumber                                 =zeros(1,sT);
 cumparameter                                  =zeros(1,sT);
 est_ratio                                     =zeros(1,6);
%==========================================================================
for f                                          =1:sT
       [K,value,sorte]                         =Gapbasedmethod(gamma{f});
       bin_estnumber(f)                        =K; 
       SORTE{f}                               =sorte;
%========================================================================== 
      index                                   =1:K; 
      maximum                                 =floor(0.15*F);  
     cumparameter(f)                          =(sum(sum(similarity{f}(index,index))))./K ;   
end
  [~,loc]                                     =sort(cumparameter,'descend');
 confidenceloc                                =loc(1:maximum);
%%=========================================================================
for i=1:6
     [~,loc]                                   =find(bin_estnumber(confidenceloc)==i);     
     est_ratio(i)                              =size(loc,2);
end
[~,ratioloc]                                   =max(est_ratio);
end