function [similarity]                                        =Feature_classification(K,features)
blocknumber              =size(features,2);
referenceblock           =1:blocknumber;
  for t                  =1:blocknumber
      index              =(t-1)*blocknumber+1: t*blocknumber;
     y(index)            =repmat(t,blocknumber,1);
  end  
   z                      =repmat(referenceblock',blocknumber,1);
%%======================================================================== 
  similarity             =zeros(blocknumber,blocknumber,K/2+1);
%%=========================================================================
Nmixtures                =size(features,1);
Ref                      =ones(Nmixtures,1)*1+1i;
abs_Ref                  =sqrt(Ref'*Ref);
%%=========================================================================
%%============== distancecalmethod        =1;============================== % 1 Similarity distance, 2, theta angle distance, 3,
method                   =2; % 1. no scaling problem, 2, scaling calculation
percent                  =8;
%%=========================================================================
 for f                   =1:K/2+1 
  [distance,~]            =distance_calculation(squeeze(features(:,:,f)).',method);
   similarity(:,:,f)      =distance;
 end
end
%==========================================================================
function      [distance,block]   =distance_calculation(X,method)
block                     =size(X,1);
%--------------------------------------------------------------------------
for i                     =1:block
    if real(X(i,1))<0
    X(i,:)                =-X(i,:);
    end
    X(i,:)                =X(i,:)./norm(X(i,:));           
end
%--------------------------------------------------------------------------
if method               ==1
  Inner                   =(X*X');
   distance                =sqrt(ones(block,block)-real(Inner));%-conj(Inner));
elseif method           ==2
      Inner              =(X*X');
 distance                =(ones(block,block)-Inner.*conj(Inner));%-conj(Inner));   
end
end