function           resultdisplay(m,n,mixture,S,estS)
%==========================================================================
figure
T                       =size(mixture(:,1),1);
for i=1:m
amplitude(i)            =max(abs(mixture(:,i)));
subplot(m,1,i)
plot(mixture(:,i));
 axis([0,T,-amplitude(i), amplitude(i)]);
  xlabel('Time (in sec.)');
   ylabel('Magnitude');
end

K=2048;overlap=0.25;fs=16000;

Or1                      =S(:,1);
Or2                      =S(:,2);
estx1                    =estS(:,1);
estx2                    =estS(:,2);
T                        =size(S(:,1),1);
for i=1:n
amplitude(i)            =max(abs(S(:,i)));
end
%==========================================================================
T                    =size(estS(:,1),1);
%==========================================================================
figure
title('Estimated Sources Amplitude','position',[5,5]);
for i=1:n
amplitude(i)            =max(abs(estS(:,i)));
subplot(n,1,i)
plot(estS(:,i))
 axis([0,T,-amplitude(i), amplitude(i)]);
   xlabel('Time (in sec.)');
   ylabel('Magnitude');
end
%==========================================================================
figure
   title('Original Sources Amplitude');
for i=1:n
  amplitude(i)            =max(abs(S(:,i)));
subplot(n,1,i)
plot(S(:,i))
 axis([0,T,-amplitude(i), amplitude(i) ]);
  xlabel('Time (in sec.)');
   ylabel('Magnitude');
end

figure;
title('Spectrum of Mixtures');
for i=1:m
   subplot(m,1,i)
   X =mixture(:,i);
spectrogram(X,K,K*(1-overlap),K,fs,'yaxis');
end

figure;
for i=1:n
   subplot(n,1,i)
   R =S(:,i);
spectrogram(R,K,K*(1-overlap),K,fs,'yaxis');
title('Original spectrum of sources');
end

figure;
for i=1:n
   subplot(n,1,i)
   Y =estS(:,i);
spectrogram(Y,K,K*(1-overlap),K,fs,'yaxis');
title('Spectrum of estimated sources');
end


