function [estH,Error]=LSchannelestimation(N,xw,sw,F)
sitaH          =1;
sita           =0;
for f          =1:F/2
    S          =squeeze(sw(:,:,f));
    X          =squeeze(xw(:,:,f));
    EH         =(S*S')\(S*X');
    estH(:,:,f)=EH.';
    Error(:,:,f)=X-EH.'*S;
end



[PSD,fp] = periodogram(S,[],'twosided',2^10,Fs);

size(PSD)

DDD
plot(fp*1e-6,PSD)

xlabel('Frequency(MHz)','fontsize', 14);

ylabel('PSD','fontsize', 14);

grid on;