function [h]=RIR_Generator(L,s,r,RT60)
c = 340;                     % Sound velocity (m/s)
fs = 16000;                  % Sample frequency (samples/s)
% r = [ 2 1.5 2 ];             % Receiver position [ x y z ] (m)
% s = [ 2 3.5 2 ];             % Source position [ x y z ] (m)
% L  =[5, 5, 2.3];             % Room dimensions [ x y z ] (m)
% RT60 = 0.15;                  % Reverberationtime (s)
%nsample = 4096;              % Number of samples
nsample = floor(RT60*16000);              % Number of samples

mtype = 'hypercardioid';     % Type of microphone
order = -1;                  % −1 equals maximum reflection order!
dim = 3;                     % Room dimension
orientation = [pi/2 0];      % Microphone orientation [azimuth elevation] in radians
hp_filter = 1;               % Enable high-pass filter

h = rir_generator(c, fs, r, s, L, RT60, nsample, mtype, order, dim, orientation, hp_filter);

figure;
plot(h);
%mex -setup
% mex rir_generator.cpp