function [newmixture, origS,origH,convolved]=dev1sourcesextraction(recordtype,sourcetype,rirlength,microdistance,J,I,numfreq)

if strcmp(sourcetype, 'music')==1 
   [newmixture,Fs]             =audioread('dev1/dev1_nodrums_synthconv_250ms_1m_mix.wav');
   newchannel                 =load('dev1/dev1_nodrums_synthconv_250ms_1m_filt.mat');           
 [s1, Fs1] = audioread('dev1/dev1_nodrums_src_1.wav');
 [s2, Fs1] = audioread('dev1/dev1_nodrums_src_2.wav');
 [s3, Fs1] = audioread('dev1/dev1_nodrums_src_3.wav');
%%=========================================================================
elseif strcmp(sourcetype, 'female')==1 
          [s1, Fs1]             = audioread('dev1/dev1_female3_src_1.wav');
      [s2, Fs2]                 = audioread('dev1/dev1_female3_src_2.wav');
      [s3, Fs3]                 = audioread('dev1/dev1_female3_src_3.wav');   
    if rirlength ==130
        if microdistance ==5      
               newchannel       =load('dev1/dev1_female3_synthconv_130ms_5cm_filt.mat');
                if strcmp( recordtype,'synthconv')==1 
          [newmixture,Fs]         =audioread('dev1/dev1_female3_synthconv_130ms_5cm_mix.wav');
          
               else
       [newmixture,Fs1]         =audioread('dev1/dev1_female3_liverec_130ms_5cm_mix.wav');
                end
        elseif microdistance ==100
             newchannel       =load('dev1/dev1_female3_synthconv_130ms_1m_filt.mat');
              if strcmp( recordtype,'synthconv')==1 
        [newmixture,Fs1]         =audioread('dev1/dev1_female3_synthconv_130ms_1m_mix.wav');
              else
        [newmixture,Fs1]         =audioread('dev1/dev1_female3_liverec_130ms_1m_mix.wav');
              end
        end
    elseif rirlength ==250
          if microdistance ==5
               newchannel       =load('dev1/dev1_female3_synthconv_250ms_5cm_filt.mat');
                if strcmp( recordtype,'synthconv')==1 
           [newmixture,Fs]      =audioread('dev1/dev1_female3_synthconv_250ms_5cm_mix.wav');
                else
            [newmixture,Fs1]         =audioread('dev1/dev1_female3_liverec_250ms_5cm_mix.wav');
                end
   elseif microdistance ==100
        newchannel              =load('dev1/dev1_female3_synthconv_250ms_1m_filt.mat'); 
         if strcmp( recordtype,'synthconv')==1 
       [newmixture,Fs1]      =audioread('dev1/dev1_female3_synthconv_250ms_1m_mix.wav');
         else
         [newmixture,Fs1]         =audioread('dev1/dev1_female3_liverec_250ms_1m_mix.wav');
         end
          end
    end
elseif strcmp(sourcetype, 'male')==1 
           [s1, Fs1]  = audioread('dev1/dev1_male3_src_1.wav');
      [s2, Fs2]        = audioread('dev1/dev1_male3_src_2.wav');
      [s3, Fs3]        = audioread('dev1/dev1_male3_src_3.wav');  
      
if rirlength ==130
     if microdistance ==5
          newchannel              =load('dev1/dev1_male3_synthconv_130ms_5cm_filt.mat'); 
          if strcmp( recordtype,'synthconv')==1 
      [newmixture,Fs]             =audioread('dev1/dev1_male3_synthconv_130ms_5cm_mix.wav');
          else
     [newmixture,Fs1]         =audioread('dev1/dev1_male3_liverec_130ms_5cm_mix.wav');
          end
    elseif microdistance ==100
         newchannel                =load('dev1/dev1_male3_synthconv_130ms_1m_filt.mat'); 
        if strcmp( recordtype,'synthconv')==1 
    [newmixture,Fs]             =audioread('dev1/dev1_male3_synthconv_130ms_1m_mix.wav');
        else
     [newmixture,Fs1]         =audioread('dev1/dev1_male3_liverec_130ms_1m_mix.wav');
        end
  end
  elseif rirlength ==250
      if microdistance ==5
          newchannel            =load('dev1/dev1_male3_synthconv_250ms_5cm_filt.mat'); 
          if strcmp( recordtype,'synthconv')==1 
        [newmixture,Fs]             =audioread('dev1/dev1_male3_synthconv_250ms_5cm_mix.wav');
          else
       [newmixture,Fs1]         =audioread('dev1/dev1_male3_liverec_250ms_5cm_mix.wav');
          end
  elseif microdistance ==100
       newchannel            =load('dev1/dev1_male3_synthconv_250ms_1m_filt.mat'); 
       if strcmp( recordtype,'synthconv')==1 
  [newmixture,Fs]             =audioread('dev1/dev1_male3_synthconv_250ms_1m_mix.wav');
       else
   [newmixture,Fs1]         =audioread('dev1/dev1_male3_liverec_250ms_1m_mix.wav');
       end
  end
end
end
%==========================================================================
    A          =40;
   len         =Fs1*10;
     S1        =s1(1:len,1);
    S2        =s2(1:len,1);
     S3        =s3(1:len,1);
   origS(:, 1) = A*S1/norm(S1);       
   origS(:, 2) = A*S2/norm(S2);
   origS(:, 3) = A*S3/norm(S3); 
  %======================================================================== 
%    Sim1            =sim1(1:len,1);
%     Sim2           =sim2(1:len,1);
%      Sim3          =sim3(1:len,1);
%    rimS(:, 1)        =A*Sim1/norm(Sim1);       
%    rimS(:, 2)        =A*Sim2/norm(Sim2);
%    rimS(:, 3)        =A*Sim3/norm(Sim3);
 %=========================================================================  
    H          =newchannel.A;
   figure;
    plot(squeeze(H(1,1,:)));
    
for so          =1:I
    for m           =1:J
        IR_all{m,so}=squeeze(H(m,so,1:end)).';%end 106
    end
end
for mic=1:J
   for so =1:I
       convolved(:, mic, so) = fftfilt(IR_all{mic, so}, origS(:, so));
    end
end
  if strcmp( recordtype,'synthconv')==1 
 newmixture                          =sum(convolved(:,1:J,1:I),3); 
  end
%=========================================================================
for i=1:J
for j=1:I
origH(i,j,:)              =fft(IR_all{i,j}(:),numfreq);% 
end
end
%%==========================================================================
   for   f                  =1:numfreq
     for i =1:I
   origH(:,i,f)          =( origH(:,i,f))./norm(( origH(:,i,f))); 
     if real(origH(1,i,f))<0
        origH(:,i,f)          =-origH(:,i,f);  
     end
      end
   end
%%=========================================================================
%figure;
%plot((1:length(IR_all{1,1})),IR_all{1,1}); %(1/Fs)*
% %axis([0 length(IR_all{1,1})  min(IR_all{1,1}) max(IR_all{1,1})]);
% Len=size(IR_all{1,1},2);
% plot((1:Len)./Fs1,IR_all{1,1}); %(1/Fs)*
% %axis([0 2000./Fs  min(IR_all{1,1}) max(IR_all{1,1})]);
% axis([0 0.25 min(IR_all{1,1}) max(IR_all{1,1})])
% %length(IR_all{1,1})
% title('Impulse Response between source 1 microphone 1')
% xlabel('Time (in seconds)');
% ylabel('Magnitude');
% %==========================================================================
% for i=1:J
% for j=1:I
% origH(i,j,:)              =fft(IR_all{i,j}(:),numfreq);% 
% end
% end
% %%==========================================================================
%    for   f                  =1:numfreq
%      for i =1:I
%      origH(:,i,f)          =( origH(:,i,f))./norm(( origH(:,i,f))); 
%       end
%    end
%%=========================================================================

